searchData={"items":[{"type":"module","title":"Utix","doc":"Miscellaneous helper functions","ref":"Utix.html"},{"type":"function","title":"Utix.app_version/1","doc":"Obtain the version of the current application.\n\nThis function must be called from a Mix project file.","ref":"Utix.html#app_version/1"},{"type":"function","title":"Options - Utix.app_version/1","doc":"- `verbose: true` - Enable printing of application version\n\nYou can also set the environment variable `SHOW_APP_VERSION=true` to\nprint application version instead of passing the keyword list to the function.","ref":"Utix.html#app_version/1-options"},{"type":"function","title":"Why is this needed? - Utix.app_version/1","doc":"When a mix project version is hard-coded in the `mix.exs` file, it is easy\nto get it out of sync with the latest tag in the git history, or the latest\ngit revision.  With this method, the app version is automatically determined\neither from the `hex.pm`'s metadata or from git history and is used to set\nthe application version in the generated `*.app` file.\n\nIf the project is loaded as a dependency from Hex.pm, then the project\ncontains \".hex\" file, which contains the version.  If it's loaded from git,\nthen we can use \"git describe\" command to format the version with a revision.\n\nOn the other hand if the dependency tries to use the\n`git describe --tags ...` command by itself, the output of the version will\nbe reflecting the version from the parent application's git history, which is\nwrong.","ref":"Utix.html#app_version/1-why-is-this-needed"},{"type":"function","title":"NOTE - Utix.app_version/1","doc":"With this method of calculating the version number, you need to make\nsure that in the Github action the checkout includes:\n```\n  - name: Checkout the repository\n    uses: actions/checkout@v4\n    with:\n      fetch-depth: 0\n```\nThis ensures that the git history is checked out with tags so that\n`git describe --tags` returns the proper version number.","ref":"Utix.html#app_version/1-note"},{"type":"function","title":"Utix.str_or_count/2","doc":"If the list length is not greater than `max_len`, stringify it.  Otherwise\nreturn the item count in the list as a string.","ref":"Utix.html#str_or_count/2"},{"type":"function","title":"Utix.write_sys_config!/3","doc":"Generate system config file (defaults to `${env}.sys.config`) from the Elixir\n`config_filename` provided in the input.","ref":"Utix.html#write_sys_config!/3"},{"type":"function","title":"Utix.write_sys_configs!/2","doc":"Generate `*.config` system config files from the files found in the `config`\ndirectory.","ref":"Utix.html#write_sys_configs!/2"},{"type":"exception","title":"Utix.Exception","doc":"General exception with an optional string, map, or Keyword list stored\nin exception details","ref":"Utix.Exception.html"},{"type":"extras","title":"utix","doc":"# utix\n\n[![Build Status](https://github.com/saleyn/utix/actions/workflows/ci.yml/badge.svg)](https://github.com/saleyn/utix/actions/workflows/ci.yml)\n[![hex.pm version](https://img.shields.io/hexpm/v/utix.svg?style=flat)](https://hex.pm/packages/utix)\n[![Hex Docs](https://img.shields.io/badge/hex-docs-lightgreen.svg?style=flat)](https://hexdocs.pm/utix/)\n[![License](https://img.shields.io/hexpm/l/utix.svg?style=flat)](https://github.com/saleyn/utix/blob/main/LICENSE.md)\n\nElixir utility library","ref":"readme.html"},{"type":"extras","title":"Installation - utix","doc":"The package can be installed by adding `utix` to your list of dependencies in\n`mix.exs`:\n\n```elixir\ndef deps do\n  [\n    {:utix, \"~> 0.1.0\"}\n  ]\nend\n```\n\nDocumentation can be found at  .","ref":"readme.html#installation"}],"content_type":"text/markdown"}